// Copyright Notice
// ================
// BOCHS is Copyright 1994,1995,1996,1997,1998 by Kevin P. Lawton.
// 
// BOCHS is commercial software.
// 
// For more information, read the file 'LICENSE' included in the bochs
// distribution.  If you don't have access to this file, or have questions
// regarding the licensing policy, the author may be contacted via:
// 
//     US Mail:  Kevin Lawton
//               528 Lexington St.
//               Waltham, MA 02154
// 
//     EMail:    bochs@world.std.com






#include "bochs.h"



INLINE void bx_cpu_c::FCOMP_STi() {bx_panic("FCOMP?:\n");}

/* NDP ESC 0 */
INLINE void bx_cpu_c::FADD_Es() {bx_panic("FADD?:\n");}
INLINE void bx_cpu_c::FMUL_Es() {bx_panic("FMUL?:\n");}
INLINE void bx_cpu_c::FCOM_Es() {bx_panic("FCOM?:\n");}
INLINE void bx_cpu_c::FCOMP_Es() {bx_panic("FCOMP?:\n");}
INLINE void bx_cpu_c::FSUB_Es() {bx_panic("FSUB?:\n");}
INLINE void bx_cpu_c::FSUBR_Es() {bx_panic("FSUBR?:\n");}
INLINE void bx_cpu_c::FDIV_Es() {bx_panic("FDIV?:\n");}
INLINE void bx_cpu_c::FDIVR_Es() {bx_panic("FDIVR?:\n");}

INLINE void bx_cpu_c::FADD_ST_STi() {bx_panic("FADD?:\n");}
INLINE void bx_cpu_c::FMUL_ST_STi() {bx_panic("FMUL?:\n");}
INLINE void bx_cpu_c::FCOM_ST_STi() {bx_panic("FCOM?:\n");}
INLINE void bx_cpu_c::FCOMP_ST_STi() {bx_panic("FCOMP?:\n");}
INLINE void bx_cpu_c::FSUB_ST_STi() {bx_panic("FSUB?:\n");}
INLINE void bx_cpu_c::FSUBR_ST_STi() {bx_panic("FSUBR?:\n");}
INLINE void bx_cpu_c::FDIV_ST_STi() {bx_panic("FDIV?:\n");}
INLINE void bx_cpu_c::FDIVR_ST_STi() {bx_panic("FDIVR?:\n");}

/* NDP ESC 1 */
INLINE void bx_cpu_c::FLD_STi() {bx_panic("FLD?:\n");}
INLINE void bx_cpu_c::FXCH_STi() {bx_panic("FXCH?:\n");}

INLINE void bx_cpu_c::FLD_Es() {bx_panic("FLD?:\n");}
/* NULL, INVALID */
INLINE void bx_cpu_c::FST_Es() {bx_panic("FST?:\n");}
INLINE void bx_cpu_c::FSTP_Es() {bx_panic("FSTP?:\n");}
INLINE void bx_cpu_c::FLDENV_Ea() {bx_panic("FLDENV?:\n");}

  INLINE void
bx_cpu_c::FLDCW_Ew()
{
bx_panic("FLDCW?:\n");
}

INLINE void bx_cpu_c::FSTENV_Ea() {bx_panic("FSTENV?:\n");}

  INLINE void
bx_cpu_c::FSTCW_Ew()
{
  Bit16u control_word;

  decode_exgx();

  control_word = 0;
  if (BX_CPU_THIS_PTR rm_type == BX_REGISTER_REF) {
    bx_panic("fstcw_ew: Ew is register\n");
    }
  else {
    write_virtual_word(BX_CPU_THIS_PTR rm_seg_reg, BX_CPU_THIS_PTR rm_addr, &control_word);
    }

  if (BX_CPU_THIS_PTR cr0.ts) {
    bx_panic("FSTCW_Ew: TS set\n");
    }
}



  INLINE void
bx_cpu_c::FNOP()
{
  bx_printf("FNOP: ignoring\n");
bx_printf("fnop @ %04x:%08x\n",
  (unsigned) bx_cpu.cs.selector.value,
  (unsigned) bx_cpu.prev_eip);
}

/* NULL, INVALID */
INLINE void bx_cpu_c::FCHS() {bx_panic("FCHS?:\n");}
INLINE void bx_cpu_c::FLD1() {bx_panic("FLD1?:\n");}
INLINE void bx_cpu_c::F2XM1() {bx_panic("F2XM1?:\n");}
INLINE void bx_cpu_c::FPREM() {bx_panic("FPREM?:\n");}


/* NULL, INVALID */
/* NULL, INVALID */
INLINE void bx_cpu_c::FABS() {bx_panic("FABS?:\n");}
INLINE void bx_cpu_c::FLDL2T() {bx_panic("FLDL2T?:\n");}
INLINE void bx_cpu_c::FYL2X() {bx_panic("FYL2X?:\n");}
INLINE void bx_cpu_c::FYL2XP1() {bx_panic("FYL2XP1?:\n");}


/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
INLINE void bx_cpu_c::FLDL2E() {bx_panic("FLDL2E?:\n");}
INLINE void bx_cpu_c::FPTAN() {bx_panic("FPTAN?:\n");}
INLINE void bx_cpu_c::FSQRT() {bx_panic("FSQRT?:\n");}

INLINE void bx_cpu_c::FXCH_3() {bx_panic("FXCH?:\n");}
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
INLINE void bx_cpu_c::FLDPI() {bx_panic("FLDPI?:\n");}
INLINE void bx_cpu_c::FPATAN() {bx_panic("FPATAN?:\n");}
INLINE void bx_cpu_c::FSINCOS() {bx_panic("FSINCOS?:\n");}


/* NULL, INVALID */
/* NULL, INVALID */
INLINE void bx_cpu_c::FTST() {bx_panic("FTST?:\n");}
INLINE void bx_cpu_c::FLDLG2() {bx_panic("FLDLG2?:\n");}
INLINE void bx_cpu_c::FXTRACT() {bx_panic("FXTRACT?:\n");}
INLINE void bx_cpu_c::FRNDINT() {bx_panic("FRNDINT?:\n");}


/* NULL, INVALID */
/* NULL, INVALID */
INLINE void bx_cpu_c::FXAM() {bx_panic("FXAM?:\n");}
INLINE void bx_cpu_c::FLDLN2() {bx_panic("FLDLN2?:\n");}
INLINE void bx_cpu_c::FPREM1() {bx_panic("FPREM1?:\n");}
INLINE void bx_cpu_c::FSCALE() {bx_panic("FSCALE?:\n");}


/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
INLINE void bx_cpu_c::FLDZ() {bx_panic("FLDZ?:\n");}
INLINE void bx_cpu_c::FDECSTP() {bx_panic("FDECSTP?:\n");}
INLINE void bx_cpu_c::FSIN() {bx_panic("FSIN?:\n");}

/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
INLINE void bx_cpu_c::FINCSTP() {bx_panic("FINCSTP?:\n");}
INLINE void bx_cpu_c::FCOS() {bx_panic("FCOS?:\n");}

/* NDP ESC 2 */
INLINE void bx_cpu_c::FIADD_Ew() {bx_panic("FIADD?:\n");}
INLINE void bx_cpu_c::FIMUL_Ew() {bx_panic("FIMUL?:\n");}
INLINE void bx_cpu_c::FICOM_Ew() {bx_panic("FICOM?:\n");}
INLINE void bx_cpu_c::FICOMP_Ew() {bx_panic("FICOMP?:\n");}
INLINE void bx_cpu_c::FISUB_Ew() {bx_panic("FISUB?:\n");}
INLINE void bx_cpu_c::FISUBR_Ew() {bx_panic("FISUBR?:\n");}
INLINE void bx_cpu_c::FIDIV_Ew() {bx_panic("FIDIV?:\n");}
INLINE void bx_cpu_c::FIDIVR_Ew() {bx_panic("FIDIVR?:\n");}

/* NULL, INVALID */
INLINE void bx_cpu_c::FUCOMPP() {bx_panic("FUCOMPP?:\n");}
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */

/* NDP ESC 3 */
INLINE void bx_cpu_c::FILD_Ew() {bx_panic("FILD?:\n");}
/* NULL, INVALID */
INLINE void bx_cpu_c::FIST_Ew() {bx_panic("FIST?:\n");}
INLINE void bx_cpu_c::FISTP_Ew() {bx_panic("FISTP?:\n");}
INLINE void bx_cpu_c::FLD_Et() {bx_panic("FLD?:\n");}
/* NULL, INVALID */
INLINE void bx_cpu_c::FSTP_Et() {bx_panic("FSTP?:\n");}
/* NULL, INVALID */

/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, GROUP3A */
/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */

/* NDP ESC 3, GROUP3a */
INLINE void bx_cpu_c::FENI() {bx_panic("FENI?:\n");}
INLINE void bx_cpu_c::FDISI() {bx_panic("FDISI?:\n");}

  INLINE void
bx_cpu_c::FCLEX()
{
  bx_printf("FCLEX: called, but no action taken.\n");
}

  INLINE void
bx_cpu_c::FINIT()
{
  bx_printf("FINIT: called, but no action taken.\n");
}

  INLINE void
bx_cpu_c::FSETPM()
{
#if BX_CPU > 2
  bx_panic("ndp.c: not implemented for 386\n");
#endif

#if BX_CPU >= 2
  if (protected_mode())
    bx_panic(
      "not yet supported for protected mode\n");
#endif

  bx_panic("FSETPM not supported!  Continuing anyway!\n");
}

/* NULL, INVALID */
/* NULL, INVALID */
/* NULL, INVALID */

/* NDP ESC 4 */
INLINE void bx_cpu_c::FADD_El() {bx_panic("FADD?:\n");}
INLINE void bx_cpu_c::FMUL_El() {bx_panic("FMUL?:\n");}
INLINE void bx_cpu_c::FCOM_El() {bx_panic("FCOM?:\n");}
INLINE void bx_cpu_c::FCOMP_El() {bx_panic("FCOMP?:\n");}
INLINE void bx_cpu_c::FSUB_El() {bx_panic("FSUB?:\n");}
INLINE void bx_cpu_c::FSUBR_El() {bx_panic("FSUBR?:\n");}
INLINE void bx_cpu_c::FDIV_El() {bx_panic("FDIV?:\n");}
INLINE void bx_cpu_c::FDIVR_El() {bx_panic("FDIVR?:\n");}

INLINE void bx_cpu_c::FADD_STi_ST() {bx_panic("FADD?:\n");}
INLINE void bx_cpu_c::FMUL_STi_ST() {bx_panic("FMUL?:\n");}
INLINE void bx_cpu_c::FCOM_STi_ST() {bx_panic("FCOM?:\n");}
INLINE void bx_cpu_c::FCOMP_STi_ST() {bx_panic("FCOMP?:\n");}
INLINE void bx_cpu_c::FSUB_STi_ST() {bx_panic("FSUB?:\n");}
INLINE void bx_cpu_c::FSUBR_STi_ST() {bx_panic("FSUBR?:\n");}
INLINE void bx_cpu_c::FDIV_STi_ST() {bx_panic("FDIV?:\n");}
INLINE void bx_cpu_c::FDIVR_STi_ST() {bx_panic("FDIVR:\n");}

/* NDP ESC 5 */
INLINE void bx_cpu_c::FLD_El() {bx_panic("FLD?:\n");}
/* NULL, INVALID */
INLINE void bx_cpu_c::FST_El() {bx_panic("FST?:\n");}
INLINE void bx_cpu_c::FSTP_El() {bx_panic("FSTP?:\n");}
INLINE void bx_cpu_c::FRSTOR_Ea() {bx_panic("FRSTOR?:\n");}
/* NULL, INVALID */
INLINE void bx_cpu_c::FSAVE_Ea() {bx_panic("FSAVE?:\n");}

  INLINE void
bx_cpu_c::FSTSW_Ew()
{
  bx_printf("FSTSW_Ew: called but no action taken\n");

  decode_exgx();

  /* do nothing: in particular, don't write any value to memory at Ew */

  if (BX_CPU_THIS_PTR cr0.ts) {
    bx_panic("FSTSW_Ew: TS set\n");
    }
}


INLINE void bx_cpu_c::FFREE_STi() {bx_panic("FFREE?:\n");}
/* NULL, INVALID */
INLINE void bx_cpu_c::FST_STi() {bx_panic("FST?:\n");}
INLINE void bx_cpu_c::FSTP_STi() {bx_panic("FSTP?:\n");}
INLINE void bx_cpu_c::FUCOM_STi_ST() {bx_panic("FUCOM?:\n");}
INLINE void bx_cpu_c::FUCOMP_STi() {bx_panic("FUCOMP?:\n");}
/* NULL, INVALID */
/* NULL, INVALID */

/* NDP ESC 6 */
INLINE void bx_cpu_c::FIADD_Ed() {bx_panic("FIADD?:\n");}
INLINE void bx_cpu_c::FIMUL_Ed() {bx_panic("FIMUL?:\n");}
INLINE void bx_cpu_c::FICOM_Ed() {bx_panic("FICOM?:\n");}
INLINE void bx_cpu_c::FICOMP_Ed() {bx_panic("FICOMP?:\n");}
INLINE void bx_cpu_c::FISUB_Ed() {bx_panic("FISUB?:\n");}
INLINE void bx_cpu_c::FISUBR_Ed() {bx_panic("FISUBR?:\n");}
INLINE void bx_cpu_c::FIDIV_Ed() {bx_panic("FIDIV?:\n");}
INLINE void bx_cpu_c::FIDIVR_Ed() {bx_panic("FIDIVR?:\n");}

INLINE void bx_cpu_c::FADDP_STi_ST() {bx_panic("FADDP?:\n");}
INLINE void bx_cpu_c::FMULP_STi_ST() {bx_panic("FMULP?:\n");}
/* NULL, INVALID */
INLINE void bx_cpu_c::FCOMPP() {bx_panic("FCOMPP?:\n");}
INLINE void bx_cpu_c::FSUBP_STi_ST() {bx_panic("FSUBP?:\n");}
INLINE void bx_cpu_c::FSUBRP_STi_ST() {bx_panic("FSUBRP?:\n");}
INLINE void bx_cpu_c::FDIVP_STi_ST() {bx_panic("FDIV?:\n");}
INLINE void bx_cpu_c::FDIVRP_STi_ST() {bx_panic("FDIVRP?:\n");}

/* NDP ESC 7 */
INLINE void bx_cpu_c::FILD_Ed()
{
#if BX_CPU > 2
  bx_panic("ndp.c: not implemented for 386\n");
#endif

#if BX_CPU >= 2
  if (protected_mode())
    bx_panic(
      "not yet supported for protected mode\n");
#endif

bx_panic("FILD:\n");
}

  INLINE void
bx_cpu_c::FIST_Ed()
{
#if BX_CPU > 2
  bx_panic("ndp.c: not implemented for 386\n");
#endif

#if BX_CPU >= 2
  if (protected_mode())
    bx_panic(
      "not yet supported for protected mode\n");
#endif

bx_panic("FIST:\n");
}

INLINE void bx_cpu_c::FISTP_Ed() {bx_panic("FISTP?:\n");}
INLINE void bx_cpu_c::FBLD_Eb() {bx_panic("FBLD?:\n");}
INLINE void bx_cpu_c::FILD_Eq() {bx_panic("FILD?:\n");}
INLINE void bx_cpu_c::FBSTP_Eb() {bx_panic("FBSTP?:\n");}
INLINE void bx_cpu_c::FISTP_Eq() {bx_panic("FISTP?:\n");}

  INLINE void
bx_cpu_c::FSTSW_AX()
{
  // do nothing - not implemented
  // ???
}
