// Copyright Notice
// ================
// BOCHS is Copyright 1994,1995,1996,1997,1998 by Kevin P. Lawton.
//
// BOCHS is commercial software.
//
// For more information, read the file 'LICENSE' included in the bochs
// distribution.  If you don't have access to this file, or have questions
// regarding the licensing policy, the author may be contacted via:
//
//     US Mail:  Kevin Lawton
//               528 Lexington St.
//               Waltham, MA 02154
//
//     EMail:    bochs@world.std.com



#include "bochs.h"


#if 0
// possible types passed to BX_INSTR_TLB_CNTRL()
#define BX_INSTR_MOV_CR3     10
#define BX_INSTR_INVLPG      11
#define BX_INSTR_TASKSWITCH  12

// possible types passed to BX_INSTR_CACHE_CNTRL()
#define BX_INSTR_INVD      20
#define BX_INSTR_WBINVD    21
#endif


// called from the CPU core
  void
bx_instr_cnear_branch(Bit32u new_eip)
{
  UNUSED(new_eip);
}

  void
bx_instr_ucnear_branch(Bit32u new_eip)
{
  UNUSED(new_eip);
}

  void
bx_instr_far_branch(Bit32u new_cs, Bit32u new_eip)
{
  UNUSED(new_eip);
  UNUSED(new_cs);
}

  void
bx_instr_opcode_byte1(Bit8u opcode)
{
  UNUSED(opcode);
}

  void
bx_instr_opcode_byte2(Bit8u opcode)
{
  UNUSED(opcode);
}

  void
bx_instr_opcode_g1ebib(unsigned nnn)
{
  UNUSED(nnn);
}

  void
bx_instr_opcode_g1eviv(unsigned nnn)
{
  UNUSED(nnn);
}

  void
bx_instr_opcode_g1evib(unsigned nnn)
{
  UNUSED(nnn);
}

  void
bx_instr_opcode_g2ebib(unsigned nnn)
{
  UNUSED(nnn);
}

  void
bx_instr_opcode_g2evib(unsigned nnn)
{
  UNUSED(nnn);
}

  void
bx_instr_opcode_g2eb1(unsigned nnn)
{
  UNUSED(nnn);
}

  void
bx_instr_opcode_g2ev1(unsigned nnn)
{
  UNUSED(nnn);
}

  void
bx_instr_opcode_g2ebcl(unsigned nnn)
{
  UNUSED(nnn);
}

  void
bx_instr_opcode_g2evcl(unsigned nnn)
{
  UNUSED(nnn);
}

  void
bx_instr_opcode_g3eb(unsigned nnn)
{
  UNUSED(nnn);
}

  void
bx_instr_opcode_g3ev(unsigned nnn)
{
  UNUSED(nnn);
}

  void
bx_instr_opcode_g4(unsigned nnn)
{
  UNUSED(nnn);
}

  void
bx_instr_opcode_g5(unsigned nnn)
{
  UNUSED(nnn);
}

  void
bx_instr_opcode_g6(unsigned nnn)
{
  UNUSED(nnn);
}

  void
bx_instr_opcode_g7(unsigned nnn)
{
  UNUSED(nnn);
}

  void
bx_instr_opcode_g8evib(unsigned nnn)
{
  UNUSED(nnn);
}

  void
bx_instr_mem_code(Bit32u linear, unsigned size)
{
  UNUSED(linear);
  UNUSED(size);
}

  void
bx_instr_mem_data(Bit32u linear, unsigned size, unsigned rw)
{
  UNUSED(linear);
  UNUSED(size);
  UNUSED(rw);
}

  void
bx_instr_opcode_begin(void)
{
}

  void
bx_instr_opcode_end(void)
{
}

  void
bx_instr_exception(unsigned vector)
{
  UNUSED(vector);
}

  void
bx_instr_tlb_cntrl(unsigned what, Bit32u newval)
{
  UNUSED(what);
  UNUSED(newval);
}

  void
bx_instr_cache_cntrl(unsigned what)
{
  UNUSED(what);
}

  void
bx_instr_hwinterrupt(unsigned vector, Bit32u cs, Bit32u eip)
{
  UNUSED(vector);
  UNUSED(cs);
  UNUSED(eip);
}

  void
bx_instr_init(void)
{
}

  void
bx_instr_shutdown(void)
{
}

  void
bx_instr_opcode_repeating(void)
{
}


// called from the debug prompt
  void
bx_instr_start(void)
{
}

  void
bx_instr_stop(void)
{
}

  void
bx_instr_reset(void)
{
}

  void
bx_instr_print(void)
{
}
